/***************************************************************
 * Name:      j11Main.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2012-12-06
 * Copyright:  ()
 * License:
 **************************************************************/

#include "j11Main.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(j11Frame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

int fd; /* Файловый дескриптор для порта */
unsigned char buf[256];/*размер зависит от размера строки принимаемых данных*/
int open_port(void);

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(j11Frame)
const long j11Frame::ID_BUTTON1 = wxNewId();
const long j11Frame::ID_STATICTEXT1 = wxNewId();
const long j11Frame::ID_STATICTEXT2 = wxNewId();
const long j11Frame::ID_STATICTEXT3 = wxNewId();
const long j11Frame::ID_STATICTEXT4 = wxNewId();
const long j11Frame::ID_STATICTEXT5 = wxNewId();
const long j11Frame::ID_STATICTEXT6 = wxNewId();
const long j11Frame::idMenuQuit = wxNewId();
const long j11Frame::idMenuAbout = wxNewId();
const long j11Frame::ID_STATUSBAR1 = wxNewId();
const long j11Frame::ID_TIMER1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(j11Frame,wxFrame)
    //(*EventTable(j11Frame)
    //*)
END_EVENT_TABLE()

j11Frame::j11Frame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(j11Frame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    SetClientSize(wxSize(797,450));
    Button1 = new wxButton(this, ID_BUTTON1, _("Scan"), wxPoint(80,32), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("X="), wxPoint(256,40), wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Label"), wxPoint(280,40), wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Y="), wxPoint(336,40), wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Label"), wxPoint(360,40), wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    StaticText5 = new wxStaticText(this, ID_STATICTEXT5, _("ADC="), wxPoint(424,40), wxDefaultSize, 0, _T("ID_STATICTEXT5"));
    StaticText6 = new wxStaticText(this, ID_STATICTEXT6, _("Label"), wxPoint(472,40), wxDefaultSize, 0, _T("ID_STATICTEXT6"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    Timer1.SetOwner(this, ID_TIMER1);
    Timer1.Start(29, false);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&j11Frame::OnButton1Click);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&j11Frame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&j11Frame::OnAbout);
    Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&j11Frame::OnTimer1Trigger);
    //*)
}

j11Frame::~j11Frame()
{
    //(*Destroy(j11Frame)
    //*)
}

void j11Frame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void j11Frame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void j11Frame::OnButton1Click(wxCommandEvent& event)
{
port_set:
    fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY); /*'open_port()' - Открывает последовательный порт */
      if (fd == -1)
        {
          Button1->SetLabel(_("!!!error port Unable to open"));
        }
     else
        {

         struct termios options; /*структура для установки порта*/
         tcgetattr(fd, &options); /*читает пораметры порта*/

         cfsetispeed(&options, B115200); /*установка скорости порта*/
         cfsetospeed(&options, B115200); /*установка скорости порта*/

         options.c_cflag &= ~PARENB; /*выкл проверка четности*/
         options.c_cflag &= ~CSTOPB; /*выкл 2-х стобит, вкл 1 стопбит*/
         options.c_cflag &= ~CSIZE; /*выкл битовой маски*/
         options.c_cflag |= CS8; /*вкл 8бит*/
         tcsetattr(fd, TCSANOW, &options); /*сохронения параметров порта*/
        }

      Timer1.Start(29, false);
}

void j11Frame::OnTimer1Trigger(wxTimerEvent& event)
{
    ++a;
	Button1->SetLabel(wxString::Format(_("a = %d"), a));
}
